<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
</head>
<body>
    <div id="app">
        <button @click="reverseMessage">Click</button>
        <p>원본 메세지: {{message}}</p>
        <p>역순 메세지: {{reversedMessage}}</p>
        <hr>
        <h2>methods 호출수: {{countCallMethods}}</h2>
        <p>역순 메세지: {{getReversedMessage()}}</p>
        <p>역순 메세지: {{getReversedMessage()}}</p>
        <hr>
        <h2>computed 호출수: {{countCallComputed}}</h2>
        <p>역순 메세지: {{getReversedMessage2}}</p>
        <p>역순 메세지: {{getReversedMessage2}}</p>
    </div>

    <script>
        new Vue({
            el: "#app",
            data: {
                message: "안녕하세요.",
                reversedMessage: "",
                countCallMethods: 0,
                countCallComputed: 0,
            },
            methods: {
                reverseMessage() {
                    this.reversedMessage = this.message.split("").reverse().join("");
                },
                // methods는 화면이 다시 렌더링될 때 호출된 수만큼 다시 호출된다.
                getReversedMessage() {
                    this.countCallMethods++;
                    return this.reversedMessage;
                }
            },
            computed: {
                // computed는 화면이 다시 렌더링될 때 한번만 호출된다.
                getReversedMessage2() {
                    this.countCallComputed++;
                    return this.reversedMessage;
                }
            }
        });
    </script>
</body>
</html>